/********************************************************************
*	flulibgraphics.cpp												*
*	By Shady El Mously												*
*	Part of the flulib game library									*
*	this file implelents very general graphics stuff that could		*
*	be used in both graphics subsystems								*
********************************************************************/

#include "graphics.h"		//	Graphics Subsystem implemented here
#include "application.h"	//	to get application width and height (for clipping lines

/********************************************************************
*	implementation of class cGraphics Subsystem						*
*	Has Very general independant graphics functions					*
********************************************************************/

//	constructor
cGraphicsSubSystem::cGraphicsSubSystem()
{
	m_NumLines=m_NumCharsPerLine=0;	
	m_bCanMultiTexture		=	false	;
	m_bCanLockArrays		=	false	;
	m_bSupportTexEnvCombine	=	false	;
	m_bSupportReflectionMap	=	false	;
	m_MaxTextureUnits		=	0		;
}


//	destructor
cGraphicsSubSystem::~cGraphicsSubSystem()
{
	for(int x=0;x<m_NumLines;x++)
		delete	[]	m_ScreenText[x];
	//	then columns
	delete	[]	m_ScreenText;
}


//	this will clear the 2d array of chatacrers ..
void cGraphicsSubSystem::ClearText()
{
	//	fill the screen with null characters
	for(int x=0;x<m_NumLines;x++)
		for(int y=0;y<m_NumCharsPerLine;y++)
			m_ScreenText[x][y]='\0';
}



//	allocate the text buffer with this just send number of rows and columns required
void cGraphicsSubSystem::AllocateTextBuffer(int NumRows,int NumColumns)
{
	//	needed for allocating characters
	m_NumLines				=	NumColumns;
	m_NumCharsPerLine		=	NumRows;

	//	allocate a 2d array with exactly the rquired size
	m_ScreenText=new char *[m_NumLines];
	int x,y;
	for(x=0;x<m_NumLines;x++)
		m_ScreenText[x]=new char[m_NumCharsPerLine+1];
	//	put zeros in all the array
	for(x=0;x<m_NumLines;x++)
			for(y=0;y<m_NumCharsPerLine+1;y++)
				m_ScreenText[x][y]='\0';

}/*---------end of class cGraphicsSubsystem implementation--------*/