#include "helmet.h"
#include "isense.h"
#include "fglove.h"
#include "opengl.h"

/****************************************************************
*	helmet.cpp													*
*	by Shady el Mously											*
*	this file is the implementation file for the classes		*
*	for the gloves and the head mounted display					*
****************************************************************/



/****************************************************************
*	class cHeadDisplay implementation							*
****************************************************************/

//	a handle to the tracker
ISD_TRACKER_HANDLE Tracker;


//	the data we will read from the tracker
ISD_DATA_TYPE	TrackerData;


//	info about the tracker
ISD_TRACKER_INFO_TYPE    TrackerInfo;


//	the constructor ..create the device used...(the handle)
cHelmetViewer::cHelmetViewer()
{
	
	//	open the tracker (initialize it)
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	Graphics()->InitDrawing2D();
	Graphics()->WriteText(0,0,0xFFFFFF,"Detecting tracker...");
	Graphics()->EndDrawing2D();
	Graphics()->Flip();


	Tracker = ISLIB_OpenTracker( NULL, 0,FALSE, FALSE );

	if(!Tracker)
	{
		Application()->ReportError("Isense.dll Not Found!");
	}

	//	if the tracker was not found.. report that
	if(Tracker==-1)
	{
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		Graphics()->InitDrawing2D();
		Graphics()->WriteText(0,0,0xFFFFFF,"Tracker Not Found !");
		Graphics()->EndDrawing2D();
		Graphics()->Flip();
		Sleep(1000);
	}
}

//	shut down the tracker
cHelmetViewer::~cHelmetViewer()
{
	//	close the tracker
	ISLIB_CloseTracker(Tracker);	
}

//	get the data from the tracker
void cHelmetViewer::GetData()
{
	//	read the tracker data
	ISLIB_GetTrackerData(Tracker, &TrackerData);

	m_Yaw	=	TrackerData.Station[0].Orientation[0];
	m_Pitch	=	TrackerData.Station[0].Orientation[1];
	m_Roll	=	TrackerData.Station[0].Orientation[2];

	//	get the tracker info
	ISLIB_GetCommInfo(Tracker,&TrackerInfo);

}
/*-------------end of class cHeadDisplay implementation---------*/